var wshShell = new ActiveXObject("WScript.Shell");
var fso = new ActiveXObject("Scripting.FileSystemObject");

function GetAppDataLocalFolder()
{
    var appDataLocalFolder = wshShell.ExpandEnvironmentStrings("%LOCALAPPDATA%");
    if (!fso.FolderExists(appDataLocalFolder)) {
        var appDataFolder = wshShell.ExpandEnvironmentStrings("%APPDATA%");
        appDataLocalFolder = appDataFolder + "\\Local";
        ReassureFolderExist(appDataLocalFolder);
    }
    return appDataLocalFolder;
}

function GetClipboardManagerAppDataLocalFolder()
{
    var folder = GetAppDataLocalFolder() + "\\ClipboardManager";
    ReassureFolderExist(folder);
    return folder;
}

function GetTempFolder()
{
    var folder = GetClipboardManagerAppDataLocalFolder() + "\\Temp";
    ReassureFolderExist(folder);
    return folder;
}

function EndsWith(str, s)
{
	var reg = new RegExp(s + "$");
	return reg.test(str);
}

function RandomString(string_length)
{
	var chars = "ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz0123456789";
	var randomString = '';
	for (var i = 0; i < string_length; i++) {
		var rnum = Math.floor(Math.random() * chars.length);
		randomString += chars.substring(rnum,rnum+1);
	}
	return randomString;
}

function ReassureFolderExist(folder)
{
    if (!fso.FolderExists(folder))
        fso.CreateFolder(folder);
}

function CopyFile(fileFrom, fileTo)
{
    fso.CopyFile(fileFrom, fileTo);
}

function ClearFolderFrom(folderName, extension)
{
    if (!fso.FolderExists(folderName))
        return;

    var f, fc, file;
    var extFull = "." + extension;

    f = fso.GetFolder(folderName);
    fc = new Enumerator(f.files);
    for (; !fc.atEnd(); fc.moveNext())
    {
        file = fc.item();
        if (EndsWith(file, extFull))
        {
            try
            {
                fso.DeleteFile(file);
            }
            catch(err){}
        }
    }
}