var debugCSharp = false;

var versionClipboardManager = "2.1.1.2";
var assemblyClipboardManager = "Com.JanZeman.ClipboardManager, Version=" + versionClipboardManager + ", Culture=neutral, PublicKeyToken=8856adb859f25750";
var dllName = "Com.JanZeman.ClipboardManager.dll";
var codebase = System.Gadget.path + "\\" + dllName;

var progIdClipboardManager = "Com.JanZeman.ClipboardManagerAX";
var clsidClipboardManager = "{FFFFFFFF-CA8D-4FC2-850D-E5A3A0BD4E45}";

var progIdAddTimestamp = "Com.JanZeman.AddTimestampPatternForm";
var clsidAddTimestamp = "{FFFFFF88-BA79-4F46-8920-6983C93E7EEF}";

var progIdFavoritesSortedList = "Com.JanZeman.DataStructures.FavoritesSortedList";
var clsidFavoritesSortedList = "{FFFFFF62-9F12-4D49-B702-E48F6248CB4D}";

var progIdAddToFavoritesForm = "Com.JanZeman.AddToFavoritesForm";
var clsidAddToFavoritesForm = "{FFFFFF05-1340-43BD-8FA7-76BD1858E301}";

function CopyDllToTempFolder()
{
    var tempFolder = GetTempFolder() + "\\";
    ClearFolderFrom(tempFolder, "dll");
    var codebaseTemp = tempFolder + RandomString(16) + ".dll";
    CopyFile(codebase, codebaseTemp);
    return codebaseTemp;
}

function RegisterClipboardManagerAX()
{
    var codebaseTemp;
    if (debugCSharp)
        codebaseTemp = codebase;
    else
        codebaseTemp = CopyDllToTempFolder();

    RegisterAX(progIdClipboardManager, progIdClipboardManager, clsidClipboardManager, assemblyClipboardManager, versionClipboardManager, codebaseTemp);
    RegisterAX(progIdAddTimestamp, progIdAddTimestamp, clsidAddTimestamp, assemblyClipboardManager, versionClipboardManager, codebaseTemp);
    RegisterAX(progIdFavoritesSortedList, progIdFavoritesSortedList, clsidFavoritesSortedList, assemblyClipboardManager, versionClipboardManager, codebaseTemp);
    RegisterAX(progIdAddToFavoritesForm, progIdAddToFavoritesForm, clsidAddToFavoritesForm, assemblyClipboardManager, versionClipboardManager, codebaseTemp);
}

function UnregisterClipboardManagerAX()
{
    UnregisterAX(progIdClipboardManager, clsidClipboardManager);
    UnregisterAX(progIdAddTimestamp, clsidAddTimestamp);
    UnregisterAX(progIdFavoritesSortedList, clsidFavoritesSortedList);
    UnregisterAX(progIdAddToFavoritesForm, clsidAddToFavoritesForm);
}